//PrOF 2018. Major thanks to YB. Some networking code learned from Lorgan. 

////Draw same for every resoulution: remove xoffset, xsize
////Reset player stats to earlier match
////Fade on game start
////Do not reset ch pos client-side?
ini_open("gg2.ini");
defaultMinPlayers = ini_read_real("Plugins", "ReadyUp_DefaultMinPlayers", 2);
ini_close();

global.matchStarted = false;
global.playingPlayers = ds_list_create();
global.rupPlayers = ds_map_create(); //Only used for drawing

global.rupPacketID = argument1;
global.rupBuffer = buffer_create();

if(global.isHost) {
	global.minPlayers = get_integer("Minimum players before allowing game to start:", defaultMinPlayers);
	gg2_write_ini("Plugins", "ReadyUp_DefaultMinPlayers", global.minPlayers);
}
else {
	global.minPlayers = -1;
}

object_event_add(RoomChangeObserver, ev_other, ev_room_start, '
	if (room_get_name(room) != "CustomMapRoom") exit;
	
	if (!instance_exists(global.ReadyUpHUD)) instance_create(0, 0, global.ReadyUpHUD);
');

object_event_add(RoomChangeObserver, ev_other, ev_room_end, '
	with(global.ReadyUpHUD) instance_destroy();
	global.matchStarted = false;
	ds_list_clear(global.playingPlayers);
	ds_map_clear(global.rupPlayers);
	with (Player) isRupReady = false;
');

/*DEBUG
object_event_add(Character, ev_draw, 0, '
    draw_text(x, y - 20, string(player.isRupReady));
');
*/

global.playerInit = '
    isRupReady = false;
';

//The first Player object is created before plugins are loaded
with (Player) execute_string(global.playerInit);
object_event_add(Player, ev_create, 0, global.playerInit);
object_event_add(Player, ev_destroy, 0, '
    ds_list_delete(global.playingPlayers, ds_list_find_index(global.playingPlayers, id));
    ds_map_delete(global.rupPlayers, id);
');

global.ReadyUpHUD = object_add();
object_set_depth(global.ReadyUpHUD, -110000);
object_event_add(global.ReadyUpHUD, ev_create, 0, '

	//Constants
	RUP_TOGGLEREADY = 1;
	RUP_FORCESTART = 2;
	RUP_SYNCMATCHSTATUS = 3;
	
	aboutToStart = false;	
	forceStarted = false;
	
	// 0: Playing Player
	// 1: Spectating player
	// 2: Playing Host
	// 3: Spectating host
	drawHelper = 0;
	
	timerHelper = -1;
	alphaHelper = 1;
	rectLinesNumber = 1;
	
	//Send sync request
	event_user(4);
');

object_event_add(global.ReadyUpHUD, ev_step, ev_step_begin, '
	
	if (global.matchStarted) instance_destroy();
	
	if (!global.isHost) {
		if (global.myself.team != TEAM_SPECTATOR) drawHelper = 0;
		else drawHelper = 1;
	}
	else {
		if (global.myself.team != TEAM_SPECTATOR) drawHelper = 2;
		else drawHelper = 3;
	}
	
	//Update playingPlayers list
	for(i = 0; i < ds_list_size(global.players); i += 1){
		player = ds_list_find_value(global.players, i);
		
		if (player.team != TEAM_SPECTATOR && !ds_list_find_value(global.playingPlayers,ds_list_find_index(global.players,player))){
			ds_list_add(global.playingPlayers, player);
		}
		
		if (player.team == TEAM_SPECTATOR){
			//Remove from playingPlayers and rupPlayers
			ds_list_delete(global.playingPlayers, ds_list_find_index(global.playingPlayers, player));
		}
	}
	
    ds_map_clear(global.rupPlayers);
	
	shouldStart = true;
	
	//Update rupPlayers with new isRupReady value for each player
	for(i = 0; i < ds_list_size(global.playingPlayers); i += 1){
		player = ds_list_find_value(global.playingPlayers, i);
		
		ds_map_add(global.rupPlayers, player, player.isRupReady);
		if(!player.isRupReady) shouldStart = false;
	}
	
	if (ds_list_empty(global.playingPlayers)) shouldStart = false;
	
	if (forceStarted) {
		shouldStart = true;
	}	
	else if (ds_list_size(global.playingPlayers) < global.minPlayers) {
		shouldStart = false;
	}
		
	if(shouldStart && !aboutToStart) {
		with (NoticeO) {
			instance_destroy();
		}
		notice = instance_create(0, 0, NoticeO);
		notice.notice = NOTICE_CUSTOM;
		notice.message = "The game is about to begin";
		aboutToStart = true;
		alarm[0] = 150 / global.delta_factor;
	}
	
	alphaHelper = 1;
	//150 : 1 = 20 : 0
	if (alarm[0] != -1) alphaHelper = (alarm[0] * global.delta_factor - 30) / 120;
');

object_event_add(global.ReadyUpHUD, ev_step, ev_step_normal, '

	if (global.matchStarted) instance_destroy();
	
	//Before everyone is ready
	//Refill game timers based on game mode.
	//Prevent Intelligences and Generator from being captured/destroyed
	if (instance_exists(CTFHUD)){
		CTFHUD.timer = CTFHUD.timeLimit;
		GameServer.syncTimer = 1;
		global.blueCaps = 0;
		global.redCaps = 0;
	}
	if (instance_exists(ControlPointHUD)){
		if (timerHelper == -1) timerHelper = global.setupTimer;
		global.setupTimer = timerHelper;
		if (ControlPointHUD.mode == 1){
			ControlPointHUD.timer = min(2*30*60,ControlPointHUD.timeLimit);
		}
		else{
			ControlPointHUD.timer = ControlPointHUD.timeLimit;
		}
		GameServer.syncTimer = 1;
	}
	if (instance_exists(KothHUD)){
		KothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(DKothHUD)){
		DKothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(GeneratorHUD)){
		GeneratorHUD.timer = GeneratorHUD.timeLimit;
		GameServer.syncTimer = 1;
		with (Generator) {
			shieldHp = maxShieldHp;
			hp = maxHp;
		}
	}
	if (instance_exists(ArenaHUD)){
		ArenaHUD.timer = ArenaHUD.timeLimit;
		ArenaHUD.cpUnlock = 45*30;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(TeamDeathmatchHUD)){
		TeamDeathmatchHUD.timer = TeamDeathmatchHUD.timeLimit;
		global.redCaps = 0;
		global.blueCaps = 0;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(InvasionHUD)){
		InvasionHUD.timer = InvasionHUD.timeLimit;
		if (timerHelper == -1) timerHelper = global.setupTimer;
		global.setupTimer = timerHelper;
		GameServer.syncTimer = 1;
	}	
');

object_event_add(global.ReadyUpHUD, ev_step, ev_step_end, '

	//Check for input
	if (!aboutToStart && !instance_exists(MenuController)) {
		if (keyboard_check_pressed(global.drop)) {
			event_user(1);
		}
		else if (keyboard_check_pressed(vk_f4)) {
			event_user(2);
		}
	}
	
	event_user(0);
	event_user(3);
');

object_event_add(global.ReadyUpHUD, ev_draw, 0, '
	xoffset = view_xview[0];
	yoffset = view_yview[0];
	xcenter = view_xview[0] + view_wview[0]/2;
	xsize = view_wview[0];
	ysize = view_hview[0];
	orangeTitle = make_color_rgb(255,102,000);
	rectHeightAddition = (1+ds_list_size(global.playingPlayers)*11)+44; //1+number of names, line takes up 11px; 33 is for the titles
	readyNameDisplay = "";
	unreadyNameDisplay = "";
	
	draw_set_halign(fa_left);
	draw_set_valign(fa_top);
	
	//Rectangle background and outline
	draw_set_color(c_black);
	draw_set_alpha(alphaHelper*0.6);
	rectX1 = xoffset+95;
	rectY1 = yoffset+245;
	rectX2 = xoffset+95+(20*9);
	rectY2 = yoffset+245+rectHeightAddition;
	draw_rectangle(rectX1, rectY1, rectX2, rectY2, false);
	draw_set_color(c_white);
	draw_set_alpha(alphaHelper*1);
	draw_rectangle(rectX1, rectY1, rectX2, rectY2, true);

	//READY PLAYERS
	for(i = 0; i < ds_list_size(global.playingPlayers); i += 1){
		player = ds_list_find_value(global.playingPlayers, i);
		if (ds_map_find_value(global.rupPlayers, player) == true){
			if (player != -1){
				readyNameDisplay += string(player.name)+"#";
			}
		}
	}

	//READY title
	draw_set_color(orangeTitle);
	readyPlayersNumber = string_count("#",readyNameDisplay);
	draw_text(xoffset+100,yoffset+250,"---Ready("+string(readyPlayersNumber)+"/"+string(ds_list_size(global.playingPlayers))+")#");

	//READY player list
	draw_set_color(c_green);
	draw_text(xoffset+99,yoffset+251,"#"+readyNameDisplay);
	draw_text(xoffset+99,yoffset+249,"#"+readyNameDisplay);
	draw_text(xoffset+101,yoffset+251,"#"+readyNameDisplay);
	draw_text(xoffset+101,yoffset+249,"#"+readyNameDisplay);
	draw_set_color(c_white);
	draw_text(xoffset+100,yoffset+250,"#"+readyNameDisplay);


	textHeightAddition1 = ((1+string_count("#",readyNameDisplay))*11)+11;


	//UNREADY PLAYERS
	for(i = 0; i < ds_list_size(global.playingPlayers); i += 1){
		player = ds_list_find_value(global.playingPlayers, i);
		if (ds_map_find_value(global.rupPlayers, player) == false){
			if (instance_exists(player)){
				if (player != -1){
					unreadyNameDisplay += string(player.name)+"#";
					//DEBUG if (keyboard_check(vk_enter)) show_message(string(player.isRupReady));
				}
			}
		}
	}

	//UNREADY title
	draw_set_color(orangeTitle);
	unreadyPlayersNumber = string_count("#",unreadyNameDisplay);
	draw_text(xoffset+100,yoffset+250+textHeightAddition1,"---Not Ready("+string(unreadyPlayersNumber)+"/"+string(ds_list_size(global.playingPlayers))+")#");

	//UNREADY player list
	draw_set_color(c_red);
	draw_text(xoffset+99,yoffset+251+textHeightAddition1,"#"+unreadyNameDisplay);
	draw_text(xoffset+99,yoffset+249+textHeightAddition1,"#"+unreadyNameDisplay);
	draw_text(xoffset+101,yoffset+251+textHeightAddition1,"#"+unreadyNameDisplay);
	draw_text(xoffset+101,yoffset+249+textHeightAddition1,"#"+unreadyNameDisplay);
	draw_set_color(c_white);
	draw_text(xoffset+100,yoffset+250+textHeightAddition1,"#"+unreadyNameDisplay);

	if (drawHelper == 1) exit;
	
	//extra information
	draw_set_halign(fa_center);
	draw_set_valign(fa_top);

	//Instructions background values
	draw_set_color(c_black);
	draw_set_alpha(alphaHelper*0.6);
	infoX1 = xoffset+xsize/2-175;
	infoY1 = yoffset+ysize/2+50;
	infoX2 = xoffset+xsize/2+177;
	
	if (drawHelper == 2)
		infoY2 = yoffset+ysize/2+75+(rectLinesNumber*11);
	else
		infoY2 = yoffset+ysize/2+60+(rectLinesNumber*11);

	//Instructions background and outline
	draw_rectangle(infoX1, infoY1, infoX2, infoY2, false);
	draw_set_color(c_white);
	draw_set_alpha(alphaHelper*1);
	draw_rectangle(infoX1, infoY1, infoX2, infoY2, true);

	//Instructions text
	switch (drawHelper) {
		case 0:
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+55, "Press " + chr(global.drop) + " to ready/unready", 1, 1, 0);
			break;
		case 2:
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+55, "Press " + chr(global.drop) + " to ready/unready", 1, 1, 0);
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+70, "Press the F4 key to force game start", 1, 1, 0);
			break;
		case 3:
			draw_text_transformed(xoffset+xsize/2, yoffset+ysize/2+55, "Press the F4 key to force game start", 1, 1, 0);
			break;
	}
	
	//Allow health and ammo HUDs to draw text properly
	draw_set_valign(fa_middle);
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user0, '
	//Receive messages as host
	if (!global.isHost) exit;
	
    while(PluginPacketGetBuffer(global.rupPacketID) != -1) {
        rupReceiveBuffer = PluginPacketGetBuffer(global.rupPacketID);
        switch(read_ubyte(rupReceiveBuffer)) {
            case RUP_TOGGLEREADY:
				//Dispatch status change
                player = PluginPacketGetPlayer(global.rupPacketID);
                player.isRupReady = !player.isRupReady;
                var playerId;
                playerId = ds_list_find_index(global.players, player);
                write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
                write_ubyte(global.rupBuffer, playerId);
                with(Player) {
                    if (id != global.myself) {
                        PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
                    }
                }
                buffer_clear(global.rupBuffer);
				break;
            case RUP_FORCESTART:
                // are clients even allowed to send that?
				//No they are not, right.
				break;
			case RUP_SYNCMATCHSTATUS:
				//Reply with matchStarted and minPlayers
                player = PluginPacketGetPlayer(global.rupPacketID);
                write_ubyte(global.rupBuffer, RUP_SYNCMATCHSTATUS);
                write_ubyte(global.rupBuffer, global.matchStarted);
				write_ubyte(global.rupBuffer, global.minPlayers);
				
				PluginPacketSendTo(global.rupPacketID, global.rupBuffer, player.id);
				buffer_clear(global.rupBuffer);
				//DEBUG show_message("Sent Gsync to id " + string(player.id));
				
				for (i = 0; i <  ds_list_size(global.playingPlayers); i += 1) {
					var getPlayer;
					getPlayer = ds_list_find_value(global.playingPlayers, i);
					if (getPlayer.isRupReady) {
						//Sync player status
						var getPlayerId;
						getPlayerId = ds_list_find_index(global.players, getPlayer);
						write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
						write_ubyte(global.rupBuffer, getPlayerId);
						//DEBUG show_message("Sent RUP sync for getPlayerId " + string(getPlayerId) + " to id " + string(other.id));
						PluginPacketSendTo(global.rupPacketID, global.rupBuffer, player.id);
						buffer_clear(global.rupBuffer);
					}
				}
				break;
        }

        buffer_clear(rupReceiveBuffer);
        PluginPacketPop(global.rupPacketID);
    }
	
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user1, '
	
	//Send status change	
	if (global.myself.team == TEAM_SPECTATOR) exit;
	
	write_ubyte(global.serverSocket, CHAT_BUBBLE);
    write_ubyte(global.serverSocket, global.myself.isRupReady + 43);
	
	if (global.isHost) {
		write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
		write_ubyte(global.rupBuffer, 0);
		with(Player) {
            if (id != global.myself) {
                PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
            }
		}
		buffer_clear(global.rupBuffer);
		//DEBUG show_message("Sent RUP_TOGGLEREADY host");
		
		// actually do it as host
		global.myself.isRupReady = !global.myself.isRupReady;
	}
	else {
		write_ubyte(global.rupBuffer, RUP_TOGGLEREADY);
		PluginPacketSend(global.rupPacketID, global.rupBuffer);
		buffer_clear(global.rupBuffer);
		//DEBUG show_message("Sent RUP_TOGGLEREADY client");
	}
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user2, '
	//Force game to start, as host
	if (!global.isHost) exit;
	
	write_ubyte(global.rupBuffer, RUP_FORCESTART);
	with(Player) {
        if (id != global.myself) {
            PluginPacketSendTo(global.rupPacketID, global.rupBuffer, id);
        }
	}
	buffer_clear(global.rupBuffer);

	for (i = 0; i < ds_list_size(global.playingPlayers); i += 1) {
		player = ds_list_find_value(global.playingPlayers, i);
		player.isRupReady = true;
	}
	
	forceStarted = true;
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user3, '
	//Read status changes as client
	if (global.isHost) exit;
	
	while(PluginPacketGetBuffer(global.rupPacketID) != -1) {
        rupReceiveBuffer = PluginPacketGetBuffer(global.rupPacketID);
        switch(read_ubyte(rupReceiveBuffer)) {
            case RUP_TOGGLEREADY:
                var playerId, player;
                playerId = read_ubyte(rupReceiveBuffer);
                player = ds_list_find_value(global.playingPlayers, playerId);
                player.isRupReady = !player.isRupReady;
				//DEBUG show_message("Received TOGGLE for playerId " + string(playerId) + " isRupReady: " + string(player.isRupReady));
			break;
			
            case RUP_FORCESTART:
                with (Player) {
					isRupReady = true;
				}
				forceStarted = true;
			break;
			
			case RUP_SYNCMATCHSTATUS:
				global.matchStarted = read_ubyte(rupReceiveBuffer);
				global.minPlayers = read_ubyte(rupReceiveBuffer);
				//DEBUG show_message(string(global.matchStarted) + " : " + string(global.minPlayers));
			break;
        }

        buffer_clear(rupReceiveBuffer);
        PluginPacketPop(global.rupPacketID);
    }
');

object_event_add(global.ReadyUpHUD, ev_other, ev_user4, '
	
	//Ask to sync match status
	if (global.isHost) exit;
	
	write_ubyte(global.rupBuffer, RUP_SYNCMATCHSTATUS);
	PluginPacketSend(global.rupPacketID, global.rupBuffer);
	buffer_clear(global.rupBuffer);
	
	//DEBUG show_message("Asked RUP_SYNCMATCHSTATUS");
');

object_event_add(global.ReadyUpHUD, ev_alarm, 0, '

	//reset character things
	with (Character){
		x = xstart;
		y = ystart;
		hp = maxHp;
		ubered = 0;
		hspeed = 0;
		vspeed = 0;
		speed = 0;
		moveStatus = 0;
		//also need to reset stats
	}
	with (Medigun){
		ubering = false;
		uberCharge = 0;
		uberReady = false;
	}

	//refill game timers based on game mode.
	if (instance_exists(CTFHUD)){
		CTFHUD.timer = CTFHUD.timeLimit;
		GameServer.syncTimer = 1;	
	}
	if (instance_exists(ControlPointHUD)){
		if (ControlPointHUD.mode == 1){
			ControlPointHUD.timer = max(7*30*60, ControlPointHUD.timeLimit);
		}
		else {
			ControlPointHUD.timer = ControlPointHUD.timeLimit;
		}
		//ControlPointHUD.timer=ControlPointHUD.timeLimit
		GameServer.syncTimer = 1;
	}
	if (instance_exists(KothHUD)){
		KothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(DKothHUD)){
		DKothHUD.cpUnlock = 900;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(GeneratorHUD)){
		GeneratorHUD.timer = GeneratorHUD.timeLimit;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(ArenaHUD)){
		ArenaHUD.timer = ArenaHUD.timeLimit;
		ArenaHUD.cpUnlock = 45*30;
		GameServer.syncTimer = 1;
		serverArenaRestart();
	}
	if (instance_exists(TeamDeathmatchHUD)){
		TeamDeathmatchHUD.timer = TeamDeathmatchHUD.timeLimit;
		global.redCaps = 0;
		global.blueCaps = 0;
		GameServer.syncTimer = 1;
	}
	if (instance_exists(InvasionHUD)){
		InvasionHUD.timer = InvasionHUD.timeLimit;
		GameServer.syncTimer = 1;
	}
	
	global.matchStarted = true;
	
	/*Done later by RoomChangeObserver on room end
	with (Player) {
		isRupReady = false;
	}
	*/
	
	instance_destroy();
');

object_event_add(PlayerControl, ev_step, ev_step_end, '
	//Receive messages as host, when match has already started
	if (!global.isHost || instance_exists(global.ReadyUpHUD)) exit;
	
    while(PluginPacketGetBuffer(global.rupPacketID) != -1) {
        rupReceiveBuffer = PluginPacketGetBuffer(global.rupPacketID);
		
        if(read_ubyte(rupReceiveBuffer) == 3 /*RUP_SYNCMATCHSTATUS*/) {
			player = PluginPacketGetPlayer(global.rupPacketID);
			write_ubyte(global.rupBuffer, 3 /*RUP_SYNCMATCHSTATUS*/);
			write_ubyte(global.rupBuffer, global.matchStarted);
			write_ubyte(global.rupBuffer, global.minPlayers);
				
			PluginPacketSendTo(global.rupPacketID, global.rupBuffer, player.id);
			buffer_clear(global.rupBuffer);
			//DEBUG show_message("Sent Gsync after match start to id " + string(player.id));
        }
        PluginPacketPop(global.rupPacketID);
    }
');